/**********************************************************************/
/*                                                                    */
/*   Licensed Materials - Property of IBM.                            */
/*   IBM XL C/C++ Advanced Edition for Linux, V9.0                    */
/*   5724-S73                                                         */
/*   Copyright IBM Corp. 2003, 2007.                                  */
/*   All Rights Reserved.                                             */
/*   US Government Users Restricted Rights -                          */
/*   Use, duplication or disclosure restricted by                     */
/*   GSA ADP Schedule Contract with IBM Corp.                         */
/*                                                                    */
/**********************************************************************/

#ifndef _BUILTINS_H
#define _BUILTINS_H 1
#if __cplusplus
#include <sys/types.h>
#ifdef __builtinDecl
#undef __builtinDecl
#endif
#define __builtinDecl extern "builtin"

__builtinDecl int __abs(int); 
__builtinDecl void __alignx(int, const void*);
__builtinDecl void* __alloca(size_t); 
__builtinDecl int __assert1(int, int, int);
__builtinDecl void __assert2(int);
__builtinDecl void __bcopy(char *, char *, int);
__builtinDecl unsigned int __check_lock_mp(const int*, int, int);
__builtinDecl unsigned int __check_lock_up(const int*, int, int);
__builtinDecl void __clear_lock_mp(const int*, int);
__builtinDecl void __clear_lock_up(const int*, int);
#ifdef _LONG_LONG
__builtinDecl unsigned int __check_lockd_mp (const long long*, long long, long long);
__builtinDecl unsigned int __check_lockd_up (const long long*, long long, long long);
__builtinDecl void __clear_lockd_mp (const long long*, long long);
__builtinDecl void __clear_lockd_up (const long long*, long long);
#endif
__builtinDecl double _Complex __cmplx (double, double);
__builtinDecl float _Complex __cmplxf (float, float);
__builtinDecl long double _Complex __cmplxl (long double, long double);
__builtinDecl long double __ibm2gccldbl( long double); 
__builtinDecl long double _Complex __ibm2gccldbl_cmplx( _Complex long double);
__builtinDecl unsigned int __cntlz4(unsigned int);
__builtinDecl unsigned int __cnttz4(unsigned int);
#ifdef _LONG_LONG
__builtinDecl unsigned int __cntlz8(unsigned long long);
__builtinDecl unsigned int __cnttz8(unsigned long long);
#endif
__builtinDecl void __eieio(void);
__builtinDecl double __fcfid(double);
__builtinDecl double __fctid(double);
__builtinDecl double __fctidz(double);
__builtinDecl double __fctiw(double);
__builtinDecl double __fctiwz(double);
__builtinDecl double __fre(double);
__builtinDecl float __frsqrtes(float);
__builtinDecl void __iospace_eieio(void);
__builtinDecl void __iospace_lwsync(void);
__builtinDecl void __iospace_sync(void);
__builtinDecl void __isync(void);
__builtinDecl long __labs(long);
__builtinDecl long long  __llabs(long long); 
__builtinDecl unsigned int __load4r(unsigned int *);
__builtinDecl unsigned short __load2r(unsigned short *);
__builtinDecl void __lwsync(void);
__builtinDecl void* __memchr(const void *, int , size_t); 
__builtinDecl int   __memcmp(const void *, const void *, size_t); 
__builtinDecl void* __memccpy(void *, const void *, int , size_t);
__builtinDecl void* __memcpy(void *, const void *, size_t);
__builtinDecl void* __memmove(void *, const void *, size_t);
__builtinDecl void* __memset(void *, int , size_t);
/*
 * Specify the number of delay cycles for a specific load.
 */
__builtinDecl void __mem_delay(const void *, const unsigned int);
__builtinDecl unsigned long __mfdcr(int);
__builtinDecl unsigned long __mfspr(int);
__builtinDecl unsigned long __mfmsr();
__builtinDecl void __mtdcr(int, unsigned long);
__builtinDecl void __mtfsb0(unsigned int);
__builtinDecl void __mtfsb1(unsigned int);
__builtinDecl void __mtfsf(unsigned int, double);
__builtinDecl void __mtfsfi(unsigned int, unsigned int);
__builtinDecl void __mtmsr(unsigned long);
__builtinDecl void __mtspr(int, unsigned long);
#ifdef _LONG_LONG
__builtinDecl long long __mulhd(long long, long long);
__builtinDecl unsigned long long __mulhdu(unsigned long long, unsigned long long);
#endif
__builtinDecl int __mulhw(int, int);
__builtinDecl unsigned int __mulhwu(unsigned int, unsigned int);
__builtinDecl int __parthds(void);
__builtinDecl int __popcnt4(unsigned int);
__builtinDecl int __poppar4(unsigned int);
#ifdef _LONG_LONG
__builtinDecl int __popcnt8(unsigned long long);
__builtinDecl int __poppar8(unsigned long long);
#endif
__builtinDecl unsigned long __popcntb(unsigned long);
__builtinDecl void __prefetch_by_load(const void*);
__builtinDecl void __prefetch_by_stream(const int, const void*);
__builtinDecl void __protected_unlimited_stream_set_go(unsigned int direction, const void* addr, unsigned int);
__builtinDecl void __protected_stream_set(unsigned int direction, const void* addr, unsigned int);
__builtinDecl void __protected_stream_count(unsigned int unit_cnt, unsigned int);
__builtinDecl void __protected_stream_go();
__builtinDecl void __protected_stream_stop(unsigned int);
__builtinDecl void __protected_stream_stop_all();
__builtinDecl void __protected_unlimited_stream_set(unsigned int direction, const void* addr, unsigned int);
__builtinDecl void __protected_unlimited_store_stream_set(unsigned int direction, const void* addr, unsigned int);
__builtinDecl void __protected_store_stream_set(unsigned int direction, const void* addr, unsigned int);
__builtinDecl void __protected_stream_count_depth(unsigned int unit_cnt, unsigned int prefetch_depth, unsigned int);
__builtinDecl void __dcbfl(const void* addr);

#ifdef _LONG_LONG
__builtinDecl unsigned long long __rdlam(unsigned long long, unsigned int, unsigned long long);
__builtinDecl unsigned long long __rldimi(unsigned long long, unsigned long long, unsigned int, unsigned long long);
__builtinDecl unsigned long long __rotatel8(unsigned long long, unsigned long long);
#endif
__builtinDecl double __readflm(void);
__builtinDecl unsigned int __rlwimi(unsigned int, unsigned int, unsigned int, unsigned int);
__builtinDecl unsigned int __rlwnm(unsigned int, unsigned int, unsigned int);
__builtinDecl unsigned int __rotatel4(unsigned int, unsigned int);
__builtinDecl double __setflm(double);
__builtinDecl double __setrnd(int);
__builtinDecl void __stfiw(const int*, double);
__builtinDecl void __store2r(unsigned short, unsigned short *);
__builtinDecl void __store4r(unsigned int, unsigned int *);
__builtinDecl char* __strcat(char *, const char *);
__builtinDecl char* __strchr(const char *, int);
__builtinDecl int   __strcmp(const char *, const char *);
__builtinDecl char* __strcpy(char *, const char *);
__builtinDecl size_t __strlen(const char *);
__builtinDecl char* __strncat(char *, const char *, size_t);
__builtinDecl int   __strncmp(const char *, const char *, size_t);
__builtinDecl char* __strncpy(char *, const char *, size_t);
__builtinDecl char* __strrchr(const char *, int);
__builtinDecl double __swdiv(double, double);
__builtinDecl double __swdiv_nochk(double, double);
__builtinDecl float __swdivs(float, float);
__builtinDecl float __swdivs_nochk(float, float);
__builtinDecl void __sync(void);
#ifdef _LONG_LONG
__builtinDecl void __tdw(long long, long long, unsigned int);
#endif
__builtinDecl void __tw(int, int, unsigned int);
__builtinDecl void __umul_dbl(unsigned long,unsigned long,unsigned long *);
__builtinDecl int __usrthds(void);

/* 
 * __fmadd (a, x, y) = [a * x + y] 
 */
__builtinDecl float __fmadds (float, float, float); 
__builtinDecl double __fmadd (double, double, double); 

/* 
 * __fmsub (a, x, y) = [a * x - y] 
 */
__builtinDecl float __fmsubs (float, float, float);
__builtinDecl double __fmsub (double, double, double);

/* 
 * __fnmadd (a, x, y) = [- (a * x + y)] 
 */
__builtinDecl float __fnmadds (float, float, float);
__builtinDecl double __fnmadd (double, double, double);

/* 
 * __fnmsub (a, x, y) = [- (a * x - y)] 
 */
__builtinDecl float __fnmsubs (float, float, float);
__builtinDecl double __fnmsub (double, double, double);

/* 
 * __fsqrt (x) = square root of x
 */
__builtinDecl float __fsqrts (float);
__builtinDecl double __fsqrt (double);

/* 
 * __frsqrte (x) = [(estimate of) 1.0/sqrt(x)] 
 */
__builtinDecl double __frsqrte (double);

/* 
 * __fres (x) = [(estimate of) 1.0/x]
 */
__builtinDecl float __fres (float);

/* 
 * if (a >= 0.0) then 
 *    __fsel (a, x, y) = x; 
 * else 
 *    __fsel (a, x, y) = y 
 */
__builtinDecl float __fsels (float, float, float);
__builtinDecl double __fsel (double, double, double);

/* 
 * __fabs (x) = |x|
 */
__builtinDecl float __fabss (float);

/* 
 * __fnabs (x) = -|x|
 */
__builtinDecl float __fnabss (float);
__builtinDecl double __fnabs (double);

/* 
 * Data Cache Block Touch. Loads the block of memory containing the 
 * specified address into the data cache.
 */
__builtinDecl void __dcbt (void *);
__builtinDecl void __dcbtst (void *);

/* 
 * Data Cache Block set to Zero. Sets the specified address in the data 
 * cache to zero (0).
 */
__builtinDecl void __dcbz (void *);

/* 
 * Data Cache Block Store. Copies the specified address in the data 
 * cache to main memory.
 */
__builtinDecl void __dcbst (const void *);

/* 
 * Data Cache Block Flush. Copies the specified address in the data 
 * cache to main memory, and marks the cache block as invalid.
 */
__builtinDecl void __dcbf (const void *);

/* 
 * Trap if the parameter is not zero
 */
__builtinDecl void __trap (int);
#if _LONG_LONG
__builtinDecl void __trapd (long long);
#endif

/*
 * Round to nearest (half-up)
 */
__builtinDecl float __frins (float);
__builtinDecl double __frin (double);

/*
 * Round to integer minus
 */
__builtinDecl float  __frims (float);
__builtinDecl double  __frim (double);

/*
 * Round towards zero
 */
__builtinDecl float  __frizs (float);
__builtinDecl double  __friz (double);

/*
 * Round to integer plus
 */
__builtinDecl float  __frips (float);
__builtinDecl double  __frip (double);

/*
 * Return address of the current function, or of one of its callers
 */
__builtinDecl void* __builtin_return_address (unsigned int level);

/*
 *  The address of the function frame of the current function, or of one of its callers
 */
__builtinDecl void* __builtin_frame_address (unsigned int level);

__builtinDecl long  __builtin_expect (long exp, long c);

/*
 * Move From Time Base (mftb) hardware instruction
 */
__builtinDecl unsigned long __mftb(); 

/*
 * Move From Time Base Upper (mftbu) hardware instruction
 */
__builtinDecl unsigned int __mftbu();

/*
 * Load Word And Reserve Indexed (lwarx) instruction
 */
__builtinDecl int __lwarx(volatile int* addr); 
 
/*
 * Load Double Word And Reserve Indexed (ldarx) instruction
 * This function only available in 64 bit mode.
 */ 
__builtinDecl long __ldarx(volatile long* addr);

/*
 * Store Word Conditional Indexed (stwcx) instruction
 */
__builtinDecl int __stwcx(volatile int* addr, int val); 

/*
 * Store Double Word Conditional Indexed (stdcx) instruction
 * This function only available in 64 bit mode.
 */
__builtinDecl int __stdcx(volatile long* addr, long val);

/*
 * Performs an atomic operation which compares the contents of a single word variable with a stored old value.
 */
__builtinDecl int __compare_and_swap(volatile int* addr, int* old_val_addr, int new_val); 

/*
 * Performs an atomic operation which compares the contents of a double word variable with a stored old value
 * This function only available in 64 bit mode.
 */
__builtinDecl int __compare_and_swaplp(volatile long* addr, long* old_val_addr, long new_val);

/*
 * Increments the single word specified by 'addr' by the amount specified by 'val' in a single atomic operation
 */
__builtinDecl int __fetch_and_add(volatile int* addr, int val); 

/*
 * Increments the double word specified by 'addr' by the amount specified by 'val' in a single atomic operation
 * This function only available in 64 bit mode.
 */
__builtinDecl long __fetch_and_addlp(volatile long* addr, long val);

/*
 * Clears bits in the single word specified by 'addr' by AND-ing that value with the input 'val' parameter, 
 * in a single atomic operation
 */
__builtinDecl unsigned int __fetch_and_and(volatile unsigned int* addr, unsigned int val); 

/*
 * Clears bits in the double word specified by 'addr' by AND-ing that value with the input 'val' parameter,
 * in a single atomic operation
 * This function only available in 64 bit mode.
 */
__builtinDecl unsigned long __fetch_and_andlp(volatile unsigned long* addr, unsigned long val);

/*
 * Sets bits in the single word specified by 'addr' by OR-ing that value with the input 'val' parameter,
 * in a single atomic operation
 */
__builtinDecl unsigned int __fetch_and_or(volatile unsigned int* addr, unsigned int val);

/*
 * Sets bits in the double word specified by 'addr' by OR-ing that value with the input 'val' parameter,
 * in a single atomic operation
 * This function only available in 64 bit mode.
 */
__builtinDecl unsigned long __fetch_and_orlp(volatile unsigned long* addr, unsigned long val);

/*
 * Sets the single word specified by 'addr' to the value or the input 'val' parameter
 * and returns the original contents of the memory location, in a single atomic operation
 */
__builtinDecl int __fetch_and_swap(volatile int* addr, int val);

/*
 * Sets the double word specified by 'addr' to the value or the input 'val' parameter
 * and returns the original contents of the memory location, in a single atomic operation
 * This function only available in 64 bit mode.
 */
__builtinDecl long __fetch_and_swaplp(volatile long* addr, long val);

/*
 * Builtin interface for hummer^2 instructions, valid only for BlueGene Linux
 */
#ifdef __bg__

 /* float, double loads */
__builtinDecl double _Complex __lfps (float * addr);
__builtinDecl double _Complex __lfxs (float * addr);
__builtinDecl double _Complex __lfpd (double * addr);
__builtinDecl double _Complex __lfxd (double * addr);

/* float, double stores */
__builtinDecl void __stfps (float * addr, double _Complex);
__builtinDecl void __stfxs (float * addr, double _Complex);
__builtinDecl void __stfpd (double * addr, double _Complex);
__builtinDecl void __stfxd (double * addr, double _Complex);
__builtinDecl void __stfpiw (int * addr, double _Complex);

/* parallel operations */
__builtinDecl double _Complex __fpadd (double _Complex, double _Complex);
__builtinDecl double _Complex __fpsub (double _Complex, double _Complex);
__builtinDecl double _Complex __fpmul (double _Complex, double _Complex);
__builtinDecl double _Complex __fxmul (double _Complex, double _Complex);
__builtinDecl double _Complex __fxpmul (double _Complex, double);
__builtinDecl double _Complex __fxsmul (double _Complex, double);

/* multiply add */
__builtinDecl double _Complex __fpmadd (double _Complex b, double _Complex a, double _Complex c);
__builtinDecl double _Complex __fpnmadd (double _Complex b, double _Complex a, double _Complex c);
__builtinDecl double _Complex __fpmsub (double _Complex b, double _Complex a, double _Complex c);
__builtinDecl double _Complex __fpnmsub (double _Complex b, double _Complex a, double _Complex c);

__builtinDecl double _Complex __fxmadd (double _Complex b, double _Complex a, double _Complex c);
__builtinDecl double _Complex __fxnmadd (double _Complex b, double _Complex a, double _Complex c);
__builtinDecl double _Complex __fxmsub (double _Complex b, double _Complex a, double _Complex c);
__builtinDecl double _Complex __fxnmsub (double _Complex b, double _Complex a, double _Complex c);

__builtinDecl double _Complex __fxcpmadd (double _Complex b, double _Complex a, double c);
__builtinDecl double _Complex __fxcsmadd (double _Complex b, double _Complex a, double c);
__builtinDecl double _Complex __fxcpnmadd (double _Complex b, double _Complex a, double c);
__builtinDecl double _Complex __fxcsnmadd (double _Complex b, double _Complex a, double c);
__builtinDecl double _Complex __fxcpmsub (double _Complex b, double _Complex a, double c);
__builtinDecl double _Complex __fxcsmsub (double _Complex b, double _Complex a, double c);
__builtinDecl double _Complex __fxcpnmsub (double _Complex b, double _Complex a, double c);
__builtinDecl double _Complex __fxcsnmsub (double _Complex b, double _Complex a, double c);

__builtinDecl double _Complex __fxcpnpma (double _Complex b, double _Complex a, double c);
__builtinDecl double _Complex __fxcsnpma (double _Complex b, double _Complex a, double c);
__builtinDecl double _Complex __fxcpnsma (double _Complex b, double _Complex a, double c);
__builtinDecl double _Complex __fxcsnsma (double _Complex b, double _Complex a, double c);

__builtinDecl double _Complex __fxcxnpma (double _Complex b, double _Complex a, double c);
__builtinDecl double _Complex __fxcxnsma (double _Complex b, double _Complex a, double c);
__builtinDecl double _Complex __fxcxma (double _Complex b, double _Complex a, double c);
__builtinDecl double _Complex __fxcxnms (double _Complex b, double _Complex a, double c);

__builtinDecl double _Complex __fpsel (double _Complex a, double _Complex b, double _Complex c);
__builtinDecl double _Complex __fpctiw (double _Complex a);
__builtinDecl double _Complex __fpctiwz (double _Complex a);
__builtinDecl double _Complex __fprsp (double _Complex a);
__builtinDecl double _Complex __fpneg (double _Complex a);
__builtinDecl double _Complex __fpabs (double _Complex a);
__builtinDecl double _Complex __fpnabs (double _Complex a);
__builtinDecl double _Complex __fxmr (double _Complex a);

/* estimates */
__builtinDecl double _Complex __fpre (double _Complex);
__builtinDecl double _Complex __fprsqrte (double _Complex);


/* convert complex data to its real/imaginary value */
__builtinDecl float __crealf(float _Complex a);
__builtinDecl double __creal(double _Complex a);
__builtinDecl long double __creall(long double _Complex a);

__builtinDecl float __cimagf(float _Complex a);
__builtinDecl double __cimag(double _Complex a);
__builtinDecl long double __cimagl(long double _Complex a);

#endif /* __bg__ */

#endif
#undef __builtinDecl
#endif
